## $Id: test_applicant.py 16717 2021-11-24 06:44:33Z henrik $
##
## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##
"""Tests for applicants and related.
"""
import grok
import shutil
import tempfile
from StringIO import StringIO
from zope.component import adapts, queryUtility
from zope.component.interfaces import IFactory
from zope.interface import verify, implements
from zope.location.interfaces import ILocation
from waeup.kofa.image.interfaces import IKofaImageFile
from waeup.kofa.imagestorage import DefaultStorage
from waeup.kofa.interfaces import IFileStoreHandler, IFileStoreNameChooser
from waeup.kofa.testing import FunctionalTestCase
from kofacustom.skeleton.applicants.applicant import (
    CustomApplicant, CustomApplicantFactory,
    )
from kofacustom.skeleton.applicants.interfaces import ICustomApplicant
from kofacustom.skeleton.testing import FunctionalLayer

class CustomApplicantTest(FunctionalTestCase):

    layer = FunctionalLayer

    def setUp(self):
        super(CustomApplicantTest, self).setUp()
        self.applicant = CustomApplicant()
        return

    def tearDown(self):
        super(CustomApplicantTest, self).tearDown()
        return

    def test_interfaces(self):
        verify.verifyClass(ICustomApplicant, CustomApplicant)
        verify.verifyObject(ICustomApplicant, self.applicant)
        return

class CustomApplicantFactoryTest(FunctionalTestCase):

    layer = FunctionalLayer

    def setUp(self):
        super(CustomApplicantFactoryTest, self).setUp()
        self.factory = CustomApplicantFactory()
        return

    def tearDown(self):
        super(CustomApplicantFactoryTest, self).tearDown()
        return

    def test_interfaces(self):
        verify.verifyClass(IFactory, CustomApplicantFactory)
        verify.verifyObject(IFactory, self.factory)

    def test_factory(self):
        obj = self.factory()
        assert isinstance(obj, CustomApplicant)

    def test_getInterfaces(self):
        implemented_by = self.factory.getInterfaces()
        assert implemented_by.isOrExtends(ICustomApplicant)
